﻿//using System;
//using System.Collections.Generic;
//using System.Linq;
//using System.Text;

//using System.Threading;
//using System.Net;
//using System.Net.Sockets;

//namespace NetworkingLibrary
//{
//    public class GameServer
//    {
//        private static int bufferSize = 100000;

//        /// <summary>
//        /// The size of the buffer to use when sending/receiving data. Default value is 100000.
//        /// </summary>
//        public static int BufferSize
//        {
//            get
//            {
//                return bufferSize;
//            }
//            set
//            {
//                if (value >= (Properties.Settings.Default.MaxBufferSize - GlobalMethods.LengthBytesLength))
//                {
//                    throw new InvalidCastException("Value must be less than " + (Properties.Settings.Default.MaxBufferSize - GlobalMethods.LengthBytesLength).ToString());
//                }
//                else
//                {
//                    bufferSize = value;
//                }
//            }
//        }

//        private bool Initialised = false;
//        private bool terminating = false;

//        /// <summary>
//        /// Whether the server is terminating. Can be set to true but not to false.
//        /// </summary>
//        public bool Terminating
//        {
//            get
//            {
//                return terminating;
//            }
//            set
//            {
//                terminating = terminating ? true : value;
//            }
//        }

//        private TcpListener TheListener;
//        private int maxConnections = 20;

//        /// <summary>
//        /// The maximum number of connections the server should accept. Default value is 100;
//        /// </summary>
//        public int MaxConnections
//        {
//            get
//            {
//                return maxConnections;
//            }
//            set
//            {
//                try
//                {
//                    if (value > -1)
//                    {
//                        maxConnections = value;
//                        while (Clients.IClients.Count > maxConnections)
//                        {
//                            Guid TheAddress = Clients.IClients.Last().Key;
//                            GameServerClients.IClient TheClients.IClient = Clients.IClients[TheAddress];
//                            if (TheClients.IClient != null)
//                            {
//                                TheClients.IClient.Stop();
//                                Clients.IClients.Remove(TheAddress);
//                            }
//                        }
//                    }
//                    else
//                    {
//                        OnError.Invoke(new ErrorMessageEventArgs("Value must be greater than or equal to 0"));
//                    }
//                }
//                catch (Exception e)
//                {
//                    OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//                }
//            }
//        }

//        private AsyncCallback AcceptSocketCallback;

//        private Dictionary<Guid, GameServerClients.IClient> Clients.IClients = new Dictionary<Guid, GameServerClients.IClient>();

//        /// <summary>
//        /// A dictionary list of all the current connections that the server has accepted.
//        /// </summary>
//        public Dictionary<Guid, GameServerClients.IClient> AllClients.IClients
//        {
//            get
//            {
//                return Clients.IClients;
//            }
//        }

//        /// <summary>
//        /// Fired when any error occurs.
//        /// </summary>
//        public event ErrorMessageDelegate OnError;

//        /// <summary>
//        /// Fired when the server accepts the maximum number of connections allowed.
//        /// </summary>
//        public event MaxConnectionsDelegate OnMaxConnections;

//        public delegate void MessageReceivedDelegate(GameServerMessageReceivedEventArgs e);
//        /// <summary>
//        /// Fired when the server receives a message (data).
//        /// </summary>
//        public event MessageReceivedDelegate OnMessageReceived;

//        public delegate void Clients.IClientDisconnectDelegate(GameServerDisconnectedEventArgs e);
//        /// <summary>
//        /// Fired when a client disconnect from the server.
//        /// </summary>
//        public event Clients.IClientDisconnectDelegate OnClients.IClientDisconnect;

//        /// <summary>
//        /// Fired when a connection is accepted.
//        /// </summary>
//        public event ConnectedDelegate OnConnectionAccepted;

//        /// <summary>
//        /// Whether the server should fire the OnMessageReceived event if the message was not intended only for the server. Default value is true.
//        /// </summary>
//        public bool MessageHiding = true;

//        /// <summary>
//        /// Default constructor.
//        /// </summary>
//        /// <param name="OnMaxConnectionsReached">See OnMaxConnections event</param>
//        /// <param name="OnAMessageReceived">See OnMessageReceived event</param>
//        public GameServer(MaxConnectionsDelegate OnMaxConnectionsReached, MessageReceivedDelegate OnAMessageReceived)
//        {
//            OnError += new ErrorMessageDelegate(GameServer_OnError);
//            OnMaxConnections += OnMaxConnectionsReached;
//            OnMessageReceived += OnAMessageReceived;
//        }

//        private void GameServer_OnError(ErrorMessageEventArgs e)
//        {
//            //Fillin - in case user does not use this event
//        }

//        private bool Initialise(int Port)
//        {
//            try
//            {
//                TheListener = new TcpListener(Dns.GetHostEntry(Dns.GetHostName()).AddressList.First(), Port);
//                AcceptSocketCallback = new AsyncCallback(AcceptSocket);
//                return true;
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//            return false;
//        }

//        /// <summary>
//        /// Initialises the server and starts it listening for connections.
//        /// </summary>
//        /// <param name="Port">The port number to listen on.</param>
//        /// <param name="MaximumConnections">See MaxConnections property.</param>
//        /// <returns>Returns true if server is initialised and starts listening.</returns>
//        public bool Start(int Port, int MaximumConnections)
//        {
//            try
//            {
//                terminating = false;

//                bool OK = true;

//                if (!Initialised)
//                {
//                    OK = Initialised = Initialise(Port);
//                }

//                if (OK)
//                {
//                    MaxConnections = MaximumConnections;
//                    TheListener.Start(MaxConnections);
//                    TheListener.BeginAcceptSocket(AcceptSocketCallback, null);
//                }

//                return OK;
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//            return false;
//        }
//        /// <summary>
//        /// Stops the server listening for connections and ends all existing connections.
//        /// </summary>
//        /// <returns>Returns true if server is stopped and all existing connections are successfully closed.</returns>
//        public bool Stop()
//        {
//            try
//            {
//                Terminating = true;

//                TheListener.Stop();
//                TheListener = null;

//                int Fails = 0;
//                for (int i = 0; i < Clients.IClients.Count; i++)
//                {
//                    GameServerClients.IClient AClients.IClient = Clients.IClients.ElementAt(i).Value;
//                    AClients.IClient.Terminating = true;
//                    if (!AClients.IClient.Stop())
//                    {
//                        Fails++;
//                    }
//                }

//                return Fails == 0 ? true : false;
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//            return false;
//        }

//        private void AcceptSocket(IAsyncResult Result)
//        {
//            try
//            {
//                if (!Terminating)
//                {
//                    if (Clients.IClients.Count < MaxConnections)
//                    {
//                        if (Result != null && TheListener != null)
//                        {
//                            Socket TheSocket = TheListener.EndAcceptSocket(Result);
//                            if (TheSocket != null)
//                            {
//                                TheSocket.Blocking = false;
//                                TheSocket.DontFragment = false;
//                                TheSocket.LingerState = new LingerOption(true, 5);
//                                TheSocket.NoDelay = true;
//                                TheSocket.ReceiveBufferSize = BufferSize;
//                                TheSocket.SendBufferSize = BufferSize;

//                                if (TheSocket.Connected)
//                                {
//                                    GameServerClients.IClient TheClients.IClient = new GameServerClients.IClient(TheSocket, ((IPEndPoint)TheSocket.RemoteEndPoint).Address, Guid.NewGuid());
//                                    TheClients.IClient.OnMessageReceived += new MessageReceivedDelegate(TheClients.IClient_OnMessageReceived);
//                                    TheClients.IClient.OnDisconnected += new GameServerClients.IClient.DisconnectedDelegate(TheClients.IClient_OnDisconnected);
//                                    Clients.IClients.Add(TheClients.IClient.ID, TheClients.IClient);
//                                    if (!TheClients.IClient.Start())
//                                    {
//                                        TheSocket.Close();
//                                        try
//                                        {
//                                            Clients.IClients.Remove(TheClients.IClient.ID);
//                                        }
//                                        catch
//                                        {
//                                        }
//                                    }
//                                    else
//                                    {
//                                        OnConnectionAccepted.Invoke();
//                                    }
//                                }

//                                TheListener.BeginAcceptSocket(AcceptSocketCallback, null);
//                            }
//                        }
//                    }
//                    if(Clients.IClients.Count >= MaxConnections)
//                    {
//                        if (OnMaxConnections != null)
//                        {
//                            OnMaxConnections.Invoke();
//                        }
//                    }
//                }
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//        }

//        private void TheClients.IClient_OnDisconnected(GameServerDisconnectedEventArgs e)
//        {
//            try
//            {
//                Clients.IClients.Remove(e.TheClients.IClient.ID);
//                try
//                {
//                    OnClients.IClientDisconnect.Invoke(e);
//                }
//                catch
//                {
//                }
//            }
//            catch
//            {
//            }
//        }

//        private void TheClients.IClient_OnMessageReceived(GameServerMessageReceivedEventArgs e)
//        {
//            try
//            {
//                List<byte[]> AllMessages = GlobalMethods.GetAllMessages(e.TheBytes);
//                for (int i = 0; i < AllMessages.Count; i++)
//                {
//                    GameServerMessageObject TheGameServerMessageObject = (GameServerMessageObject)(GlobalMethods.FromBytes(AllMessages[i]));
//                    if (TheGameServerMessageObject != null)
//                    {
//                        if (!TheGameServerMessageObject.CloseConnection)
//                        {
//                            if (TheGameServerMessageObject.ServerOnly || !MessageHiding)
//                            {
//                                if (!TheGameServerMessageObject.ServerOnly)
//                                {
//                                    Send(e.TheBytes, e.TheClients.IClient.ID);
//                                }
//                                OnMessageReceived.Invoke(new GameServerMessageReceivedEventArgs(TheGameServerMessageObject.TheBytes, e.TheClients.IClient));
//                            }
//                            else
//                            {
//                                Send(e.TheBytes, e.TheClients.IClient.ID);
//                            }
//                        }
//                        else
//                        {
//                            e.TheClients.IClient.Stop();
//                            OnMessageReceived.Invoke(new GameServerMessageReceivedEventArgs(TheGameServerMessageObject.TheBytes, e.TheClients.IClient));
//                        }
//                    }
//                }
//            }
//            catch
//            {
//            }
//        }

//        /// <summary>
//        /// Sends the specified data to all clients.
//        /// </summary>
//        /// <param name="TheBuffer">The data in byte array form. (Use GlobalMethods.ToBytes to convert a serialisable object to a byte array)</param>
//        /// <returns>Returns true if data is sent to all clients.</returns>
//        public bool Send(byte[] TheBuffer)
//        {
//            try
//            {
//                if (Initialised && !Terminating)
//                {
//                    bool All = true;

//                    foreach (GameServerClients.IClient AClients.IClient in Clients.IClients.Values)
//                    {
//                        bool Sent = AClients.IClient.Send(TheBuffer);
//                        All = !All ? All : Sent;
//                    }

//                    return All;
//                }
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//            return false;
//        }
//        /// <summary>
//        /// Sends the specified data to all clients except the specified client.
//        /// </summary>
//        /// <param name="TheBuffer">The data in byte array form. (Use GlobalMethods.ToBytes to convert a serialisable object to a byte array)</param>
//        /// <param name="ExcludeID">The ID of the client to exclude.</param>
//        /// <returns>Returns true if data is sent to all clients excluding the specified client.</returns>
//        public bool Send(byte[] TheBuffer, Guid ExcludeID)
//        {
//            try
//            {
//                if (Initialised && !Terminating)
//                {
//                    bool All = true;

//                    foreach (GameServerClients.IClient AClients.IClient in Clients.IClients.Values)
//                    {
//                        if (AClients.IClient.ID != ExcludeID)
//                        {
//                            bool Sent = AClients.IClient.Send(TheBuffer);
//                            All = !All ? All : Sent;
//                        }
//                    }

//                    return All;
//                }
//            }
//            catch (Exception e)
//            {
//                OnError.Invoke(new ErrorMessageEventArgs(e.Message));
//            }
//            return false;
//        }
//    }

//    public class GameServerMessageReceivedEventArgs : EventArgs
//    {
//        /// <summary>
//        /// The data that was received.
//        /// </summary>
//        public byte[] TheBytes;
//        /// <summary>
//        /// The game server client that received the data.
//        /// </summary>
//        public GameServerClients.IClient TheClients.IClient;

//        internal GameServerMessageReceivedEventArgs(byte[] ABytes)
//        {
//            TheBytes = ABytes;
//        }
//        internal GameServerMessageReceivedEventArgs(byte[] ABytes, GameServerClients.IClient AClients.IClient)
//        {
//            TheBytes = ABytes;
//            TheClients.IClient = AClients.IClient;
//        }
//    }

//    public class GameServerClients.IClient
//    {
//        private Socket TheSocket;
//        private IPAddress remoteAddress;

//        /// <summary>
//        ///  The IP address of the connections remote end point.
//        /// </summary>
//        public IPAddress RemoteAddress
//        {
//            get
//            {
//                return remoteAddress;
//            }
//        }
//        /// <summary>
//        /// The client's ID.
//        /// </summary>
//        public Guid ID;

//        internal bool Terminating = false;
        
//        private ManualResetEvent TerminateWait = new ManualResetEvent(false);

//        private AsyncCallback ReceiveCallback;

//        internal event GameServer.MessageReceivedDelegate OnMessageReceived;

//        internal delegate void DisconnectedDelegate(GameServerDisconnectedEventArgs e);
//        internal event DisconnectedDelegate OnDisconnected;

//        internal GameServerClients.IClient(Socket ASocket, IPAddress ARemoteAddress, Guid AnID)
//        {
//            TheSocket = ASocket;
//            remoteAddress = ARemoteAddress;
//            ID = AnID;
//        }

//        internal bool Start()
//        {
//            try
//            {
//                ReceiveCallback = new AsyncCallback(Read);
//                byte[] TheBuffer = new byte[GameServer.BufferSize];
//                TheSocket.BeginReceive(TheBuffer, 0, TheBuffer.Length, SocketFlags.None, ReceiveCallback, TheBuffer);
//                return true;
//            }
//            catch
//            {
//            }
//            return false;
//        }
        
//        private void Read(IAsyncResult Result)
//        {
//            try
//            {
//                int BytesRead = TheSocket.EndReceive(Result);

//                if (!Terminating)
//                {
//                    if (TheSocket.Connected)
//                    {
//                        byte[] TheBuffer = new byte[GameServer.BufferSize];
//                        TheSocket.BeginReceive(TheBuffer, 0, TheBuffer.Length, SocketFlags.None, ReceiveCallback, TheBuffer);
//                    }
//                    else
//                    {
//                        Stop();
//                    }
//                }

//                if (BytesRead > 0)
//                {
//                    OnMessageReceived.Invoke(new GameServerMessageReceivedEventArgs((byte[])(Result.AsyncState), this));
//                }
//                else
//                {
//                    Stop();
//                }

//            }
//            catch
//            {
//            }
//        }

//        /// <summary>
//        /// Sends the specified data to the client.
//        /// </summary>
//        /// <param name="TheBuffer">The data in byte array form. (Use GlobalMethods.ToBytes to convert a serialisable object to a byte array)</param>
//        /// <returns>Returns true if data is sent to the client.</returns>
//        public bool Send(byte[] TheBuffer)
//        {
//            try
//            {
//                TheSocket.Send(TheBuffer);
//                return true;
//            }
//            catch
//            { 
//            }
//            return false;
//        }

//        internal bool Stop()
//        {
//            try
//            {
//                Terminating = true;

//                TheSocket.Close();
//                OnDisconnected.Invoke(new GameServerDisconnectedEventArgs(this));

//                return !TheSocket.Connected;
//            }
//            catch
//            {
//            }
//            return false;
//        }
//    }

//    [Serializable]
//    internal class GameServerMessageObject
//    {
//        /// <summary>
//        /// Whether the message is intended only for the server or all the game server's clients.
//        /// </summary>
//        public bool ServerOnly = false;
//        /// <summary>
//        /// The data that was received/sent.
//        /// </summary>
//        public byte[] TheBytes;
//        public bool CloseConnection = false;

//        internal GameServerMessageObject(byte[] ABytes, bool IsServerOnly, bool ShouldCloseConnection)
//        {
//            TheBytes = ABytes;
//            ServerOnly = IsServerOnly;
//            CloseConnection = ShouldCloseConnection;
//        }
//    }

//    public class GameServerDisconnectedEventArgs : EventArgs
//    {
//        public GameServerClients.IClient TheClients.IClient;

//        internal GameServerDisconnectedEventArgs(GameServerClients.IClient AClients.IClient)
//        {
//            TheClients.IClient = AClients.IClient;
//        }
//    }

//}
